package rg

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DelStoragePolicyRequest struct for deleting storage policy to the resource group
type DelStoragePolicyRequest struct {
	// ID of resource group
	// Required: true
	RGID uint64 `url:"resgroup_id" json:"resgroup_id" validate:"required"`

	// ID of the storage policy to which to disconnect account
	// Required: true
	StoragePolicyID uint64 `url:"storage_policy_id" json:"storage_policy_id" validate:"required"`
}

// DelStoragePolicy delete storage policy to the account.
func (r RG) DelStoragePolicy(ctx context.Context, req DelStoragePolicyRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/rg/del_storage_policy"

	res, err := r.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}
